# Conditional build:
%bcond_without	kernel		# don't build kernel modules
%bcond_with	verbose		# verbose build (V=1)
%bcond_without	userspace	# don't build userspace programs
%bcond_without	dkms		# build dkms package

%if 0%{?_pld_builder:1} && %{with kernel} && %{with userspace}
%{error:kernel and userspace cannot be built at the same time on PLD builders}
exit 1
%endif

%if %{without userspace}
%undefine	with_dkms
%endif

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		rel	8
%define		pname	wl
%define		file_ver	%(echo %{version} | tr . _)
Summary:	Broadcom 802.11 a/b/g/n hybrid Linux networking device driver
Name:		%{pname}%{?_pld_builder:%{?with_kernel:-kernel}}%{_alt_kernel}
Version:	6.30.223.248
Release:	%{rel}%{?_pld_builder:%{?with_kernel:@%{_kernel_ver_str}}}
License:	other
Group:		Base/Kernel
Source0:	http://www.broadcom.com/docs/linux_sta/hybrid-v35-nodebug-pcoem-%{file_ver}.tar.gz
# Source0-md5:	e048154b3f4c7ad6bee36cab5b37486d
Source1:	http://www.broadcom.com/docs/linux_sta/hybrid-v35_64-nodebug-pcoem-%{file_ver}.tar.gz
# Source1-md5:	0237917f75d121589ec16a44eac5f5b0
Source2:	http://www.broadcom.com/docs/linux_sta/README.txt
# Source2-md5:	8a6e8708a5e00ab6d841cde51d70eb1b
Source3:	dkms.conf
Patch0:		linux-3.17.patch
Patch1:		gcc-4.9.patch
URL:		http://www.broadcom.com/support/802.11/linux_sta.php
BuildRequires:	rpmbuild(macros) >= 1.701
%{?with_kernel:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:2.6.20.2}}
ExclusiveArch:	%{ix86} %{x8664} x32
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
These packages contain Broadcom's IEEE 802.11a/b/g/n hybrid Linux
device driver for use with Broadcom's BCM4311-, BCM4312-, BCM4313-,
BCM4321-, BCM4322-, BCM43224-, and BCM43225-, BCM43227- and
BCM43228-based hardware.

This is an Official Release of Broadcom's hybrid Linux driver for use
with Broadcom based hardware.

%package -n dkms-%{pname}
Summary:	DKMS-ready driver for Broadcom WL driver
Group:		Base/Kernel
Release:	%{rel}
Requires(pre):	dkms
Requires(post):	dkms
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description -n dkms-%{pname}
This package contains a DKMS-ready driver for Broadcom WL driver.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-net-wl\
Summary:	Broadcom 802.11 a/b/g/n hybrid Linux networking device driver\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-net-wl\
These packages contain Broadcom's IEEE 802.11a/b/g/n hybrid Linux\
device driver for use with Broadcom's BCM4311-, BCM4312-, BCM4313-,\
BCM4321-, BCM4322-, BCM43224-, and BCM43225-, BCM43227- and\
BCM43228-based hardware.\
\
This is an Official Release of Broadcom's hybrid Linux driver for use\
with Broadcom based hardware.\
\
%files -n kernel%{_alt_kernel}-net-wl\
%defattr(644,root,root,755)\
%doc lib/LICENSE.txt README.txt\
/lib/modules/%{_kernel_ver}/kernel/drivers/net/wireless/*.ko*\
\
%post -n kernel%{_alt_kernel}-net-wl\
%depmod %{_kernel_ver}\
\
%posttrans -n kernel%{_alt_kernel}-net-wl\
%banner -e kernel%{_alt_kernel}-net-wl <<EOF\
WARNING! This kernel module is not GPL licensed.\
Before using it be sure to accept license: %{_docdir}/kernel%{_alt_kernel}-net-wl-%{version}/LICENSE.txt*\
EOF\
\
%postun -n kernel%{_alt_kernel}-net-wl\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%build_kernel_modules -m wl\
%install_kernel_modules -D installed -m wl -d kernel/drivers/net/wireless\
%{nil}

%{?with_kernel:%{expand:%create_kernel_packages}}

%prep
%ifarch %{x8664} x32
%define src 1
%else
%define src 0
%endif
%setup -c -T -q -n %{pname}-%{version} -b%{src}
%patch0 -p1
%patch1 -p1

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

cp -p %{SOURCE2} .

cat > Makefile << 'EOF'
obj-m	+= wl.o

wl-objs		+= src/wl/sys/wl_linux.o
wl-objs		+= src/wl/sys/wl_iw.o
wl-objs		+= src/shared/linux_osl.o

EXTRA_CFLAGS	+= -I$(KBUILD_EXTMOD)/src/include
EXTRA_CFLAGS	+= -I$(KBUILD_EXTMOD)/src/common/include
EXTRA_CFLAGS	+= -I$(KBUILD_EXTMOD)/src/wl/sys
EXTRA_CFLAGS	+= -I$(KBUILD_EXTMOD)/src/shared/bcmwifi/include

EXTRA_LDFLAGS	:= $(KBUILD_EXTMOD)/lib/wlc_hybrid.o_shipped
EOF

%build
%{?with_kernel:%{expand:%build_kernel_packages}}

%install
rm -rf $RPM_BUILD_ROOT
%if %{with kernel}
install -d $RPM_BUILD_ROOT
cp -a installed/* $RPM_BUILD_ROOT
%endif

%if %{with dkms}
install -d $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}
cp -a Makefile lib src $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}
sed -e 's|@pname@|%{pname}|g' -e 's|@MODVERSION@|%{version}-%{rel}|g' \
	%{SOURCE3} > $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}/dkms.conf
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n dkms-%{pname}
%{_sbindir}/dkms add -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade && \
%{_sbindir}/dkms build -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade && \
%{_sbindir}/dkms install -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade || :

%preun -n dkms-%{pname}
%{_sbindir}/dkms remove -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade --all || :

%if %{with dkms}
%files -n dkms-%{pname}
%defattr(644,root,root,755)
%{_usrsrc}/%{pname}-%{version}-%{rel}
%endif
%changelog
* Thu Nov 12 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/wl.git;a=log;h=auto/th/wl-6.30.223.248-8

* Tue Mar 03 2015 Jan Rękorajski <baggins@pld-linux.org> 42a6a3d
- fix package naming
- rel 8

* Tue Mar 03 2015 Jan Rękorajski <baggins@pld-linux.org> b0a31fc
- use 64bit binary blob on x32
- rel 7

* Mon Mar 02 2015 Jan Rękorajski <baggins@pld-linux.org> 04b7561
- release 6 (by relup.sh)

* Mon Mar 02 2015 Jan Rękorajski <baggins@pld-linux.org> a613bf1
- that's binary driver, no version for x32

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> 14b68eb
- x32 rebuild
- release 5 (by relup.sh)

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> 493de62
- enable dkms for consistency

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> c0eef97
- add x32 to the list of supported archs

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> cd0280d
- wrap dkms in userspace bcond

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> 747711c
- rel 4

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> 87d5fa4
- updated kernel modules build system

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> f989711
- drop non-dist kernl support

* Thu Dec 11 2014 Jan Rękorajski <baggins@pld-linux.org> 96ba8ab
- 3.14 already uses gcc 4.9 features
- rel 3

* Thu Dec 11 2014 Jan Rękorajski <baggins@pld-linux.org> 1f72301
- fix build with kernels using gcc 4.9 features
- rel 2

* Sun Nov 09 2014 Jan Rękorajski <baggins@pld-linux.org> 10c48a9
- fix building with linux 2.17
- rel 1

* Sat Nov 08 2014 Jan Rękorajski <baggins@pld-linux.org> e9e4c66
- rel 0.1, doesn't build on 3.17

* Sat Nov 08 2014 Jan Rękorajski <baggins@pld-linux.org> c242959
- updated to 6.30.223.248

* Tue Oct 29 2013 Jan Rękorajski <baggins@pld-linux.org> 3998223
- no real userspace here

* Tue Oct 29 2013 Jan Rękorajski <baggins@pld-linux.org> ed65694
- switch to macro driven module build for multiple kernel versions
- rel 4

* Tue Oct 29 2013 Jan Rękorajski <baggins@pld-linux.org> 7cf0269
- moved kernel module to subpackage

* Tue Oct 29 2013 Jan Rękorajski <baggins@pld-linux.org> ba381e2
- renamed kernel-net-wl package to wl

